summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--ChangeLog3
-rw-r--r--Makefile.in50
-rw-r--r--acconfig.h4
-rw-r--r--configure.in1
-rwxr-xr-xinstall-sh251
-rw-r--r--scp.c10
-rw-r--r--ssh-add.c4
7 files changed, 291 insertions, 32 deletions
diff --git a/ChangeLog b/ChangeLog
index 73af996e..75b8318d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -21,6 +21,9 @@
postpone fork_after_authentication until command execution,
request/patch from jahakala@cc.jyu.fi via damien@ibs.com.au
plus: use daemon() for backgrounding
+ - Added BSD compatible install program and autoconf test, thanks to
+ Niels Kristian Bech Jensen <nkbj@image.dk>
+ - Solaris fixing, thanks to Ben Taylor <bent@clark.net>
19991124
- Merged very large OpenBSD source code reformat
diff --git a/Makefile.in b/Makefile.in
index 298790a3..ec7f0fd7 100644
--- a/Makefile.in
+++ b/Makefile.in
@@ -17,6 +17,8 @@ TARGETS=libssh.a ssh sshd ssh-add ssh-keygen ssh-agent scp $(EXTRA_TARGETS)
LIBS=@LIBS@
AR=@AR@
RANLIB=@RANLIB@
+INSTALL=@INSTALL@
+LFLAGS=@LDFLAGS@
GNOME_CFLAGS=`gnome-config --cflags gnome gnomeui`
GNOME_LIBS=`gnome-config --libs gnome gnomeui`
@@ -61,40 +63,40 @@ clean:
rm -f *.o core $(TARGETS) config.status config.cache config.log
install: all
- install -d $(bindir)
- install -d $(sbindir)
- install -d $(mandir)
- install -d $(mandir)/man1
- install -d $(mandir)/man8
- install -s -c ssh $(bindir)/ssh
- install -s -c scp $(bindir)/scp
- install -s -c ssh-add $(bindir)/ssh-add
- install -s -c ssh-agent $(bindir)/ssh-agent
- install -s -c ssh-keygen $(bindir)/ssh-keygen
- install -s -c sshd $(sbindir)/sshd
- install -m644 -c ssh.1 $(mandir)/man1/ssh.1
- install -m644 -c scp.1 $(mandir)/man1/scp.1
- install -m644 -c ssh-add.1 $(mandir)/man1/ssh-add.1
- install -m644 -c ssh-agent.1 $(mandir)/man1/ssh-agent.1
- install -m644 -c ssh-keygen.1 $(mandir)/man1/ssh-keygen.1
- install -m644 -c sshd.8 $(mandir)/man8/sshd.8
+ $(INSTALL) -d $(bindir)
+ $(INSTALL) -d $(sbindir)
+ $(INSTALL) -d $(mandir)
+ $(INSTALL) -d $(mandir)/man1
+ $(INSTALL) -d $(mandir)/man8
+ $(INSTALL) -s -c ssh $(bindir)/ssh
+ $(INSTALL) -s -c scp $(bindir)/scp
+ $(INSTALL) -s -c ssh-add $(bindir)/ssh-add
+ $(INSTALL) -s -c ssh-agent $(bindir)/ssh-agent
+ $(INSTALL) -s -c ssh-keygen $(bindir)/ssh-keygen
+ $(INSTALL) -s -c sshd $(sbindir)/sshd
+ $(INSTALL) -m644 -c ssh.1 $(mandir)/man1/ssh.1
+ $(INSTALL) -m644 -c scp.1 $(mandir)/man1/scp.1
+ $(INSTALL) -m644 -c ssh-add.1 $(mandir)/man1/ssh-add.1
+ $(INSTALL) -m644 -c ssh-agent.1 $(mandir)/man1/ssh-agent.1
+ $(INSTALL) -m644 -c ssh-keygen.1 $(mandir)/man1/ssh-keygen.1
+ $(INSTALL) -m644 -c sshd.8 $(mandir)/man8/sshd.8
ln -sf ssh $(bindir)/slogin
ln -sf ssh.1 $(mandir)/man1/slogin.1
if [ "x@INSTALL_ASKPASS@" = "xyes" ] ; then \
- install -d $(libexecdir) ; \
- install -d $(libexecdir)/ssh ; \
+ $(INSTALL) -d $(libexecdir) ; \
+ $(INSTALL) -d $(libexecdir)/ssh ; \
if [ -z "@GNOME_ASKPASS@" ] ; then \
- install -m755 -c ssh-askpass ${ASKPASS_PROGRAM}; \
+ $(INSTALL) -m755 -c ssh-askpass ${ASKPASS_PROGRAM}; \
else \
- install -m755 -c gnome-ssh-askpass ${ASKPASS_PROGRAM}; \
+ $(INSTALL) -m755 -c gnome-ssh-askpass ${ASKPASS_PROGRAM}; \
fi ; \
fi
if [ ! -f $(sysconfdir)/ssh_config -a ! -f $(sysconfdir)/sshd_config ]; then \
- install -d $(sysconfdir); \
- install -m644 ssh_config $(sysconfdir)/ssh_config; \
- install -m644 sshd_config $(sysconfdir)/sshd_config; \
+ $(INSTALL) -d $(sysconfdir); \
+ $(INSTALL) -m644 ssh_config $(sysconfdir)/ssh_config; \
+ $(INSTALL) -m644 sshd_config $(sysconfdir)/sshd_config; \
fi
distclean: clean
diff --git a/acconfig.h b/acconfig.h
index 86ce003a..e6892ee5 100644
--- a/acconfig.h
+++ b/acconfig.h
@@ -167,12 +167,16 @@ enum
#ifndef _PATH_UTMP
# ifdef UTMP_FILE
# define _PATH_UTMP UTMP_FILE
+# else
+# define _PATH_UTMP "/var/adm/utmp"
# endif
#endif
#ifndef _PATH_WTMP
# ifdef WTMP_FILE
# define _PATH_WTMP WTMP_FILE
+# else
+# define _PATH_WTMP "/var/adm/wtmp"
# endif
#endif
diff --git a/configure.in b/configure.in
index 9f545d73..0de61631 100644
--- a/configure.in
+++ b/configure.in
@@ -6,6 +6,7 @@ dnl Checks for programs.
AC_PROG_CC
AC_PROG_CPP
AC_PROG_RANLIB
+AC_PROG_INSTALL
AC_CHECK_PROG(AR, ar, ar)
if test "$GCC" = "yes"; then CFLAGS="$CFLAGS -Wall"; fi
diff --git a/install-sh b/install-sh
new file mode 100755
index 00000000..e9de2384
--- /dev/null
+++ b/install-sh
@@ -0,0 +1,251 @@
+#!/bin/sh
+#
+# install - install a program, script, or datafile
+# This comes from X11R5 (mit/util/scripts/install.sh).
+#
+# Copyright 1991 by the Massachusetts Institute of Technology
+#
+# Permission to use, copy, modify, distribute, and sell this software and its
+# documentation for any purpose is hereby granted without fee, provided that
+# the above copyright notice appear in all copies and that both that
+# copyright notice and this permission notice appear in supporting
+# documentation, and that the name of M.I.T. not be used in advertising or
+# publicity pertaining to distribution of the software without specific,
+# written prior permission. M.I.T. makes no representations about the
+# suitability of this software for any purpose. It is provided "as is"
+# without express or implied warranty.
+#
+# Calling this script install-sh is preferred over install.sh, to prevent
+# `make' implicit rules from creating a file called install from it
+# when there is no Makefile.
+#
+# This script is compatible with the BSD install script, but was written
+# from scratch. It can only install one file at a time, a restriction
+# shared with many OS's install programs.
+
+
+# set DOITPROG to echo to test this script
+
+# Don't use :- since 4.3BSD and earlier shells don't like it.
+doit="${DOITPROG-}"
+
+
+# put in absolute paths if you don't have them in your path; or use env. vars.
+
+mvprog="${MVPROG-mv}"
+cpprog="${CPPROG-cp}"
+chmodprog="${CHMODPROG-chmod}"
+chownprog="${CHOWNPROG-chown}"
+chgrpprog="${CHGRPPROG-chgrp}"
+stripprog="${STRIPPROG-strip}"
+rmprog="${RMPROG-rm}"
+mkdirprog="${MKDIRPROG-mkdir}"
+
+transformbasename=""
+transform_arg=""
+instcmd="$mvprog"
+chmodcmd="$chmodprog 0755"
+chowncmd=""
+chgrpcmd=""
+stripcmd=""
+rmcmd="$rmprog -f"
+mvcmd="$mvprog"
+src=""
+dst=""
+dir_arg=""
+
+while [ x"$1" != x ]; do
+ case $1 in
+ -c) instcmd="$cpprog"
+ shift
+ continue;;
+
+ -d) dir_arg=true
+ shift
+ continue;;
+
+ -m) chmodcmd="$chmodprog $2"
+ shift
+ shift
+ continue;;
+
+ -o) chowncmd="$chownprog $2"
+ shift
+ shift
+ continue;;
+
+ -g) chgrpcmd="$chgrpprog $2"
+ shift
+ shift
+ continue;;
+
+ -s) stripcmd="$stripprog"
+ shift
+ continue;;
+
+ -t=*) transformarg=`echo $1 | sed 's/-t=//'`
+ shift
+ continue;;
+
+ -b=*) transformbasename=`echo $1 | sed 's/-b=//'`
+ shift
+ continue;;
+
+ *) if [ x"$src" = x ]
+ then
+ src=$1
+ else
+ # this colon is to work around a 386BSD /bin/sh bug
+ :
+ dst=$1
+ fi
+ shift
+ continue;;
+ esac
+done
+
+if [ x"$src" = x ]
+then
+ echo "install: no input file specified"
+ exit 1
+else
+ true
+fi
+
+if [ x"$dir_arg" != x ]; then
+ dst=$src
+ src=""
+
+ if [ -d $dst ]; then
+ instcmd=:
+ chmodcmd=""
+ else
+ instcmd=mkdir
+ fi
+else
+
+# Waiting for this to be detected by the "$instcmd $src $dsttmp" command
+# might cause directories to be created, which would be especially bad
+# if $src (and thus $dsttmp) contains '*'.
+
+ if [ -f $src -o -d $src ]
+ then
+ true
+ else
+ echo "install: $src does not exist"
+ exit 1
+ fi
+
+ if [ x"$dst" = x ]
+ then
+ echo "install: no destination specified"
+ exit 1
+ else
+ true
+ fi
+
+# If destination is a directory, append the input filename; if your system
+# does not like double slashes in filenames, you may need to add some logic
+
+ if [ -d $dst ]
+ then
+ dst="$dst"/`basename $src`
+ else
+ true
+ fi
+fi
+
+## this sed command emulates the dirname command
+dstdir=`echo $dst | sed -e 's,[^/]*$,,;s,/$,,;s,^$,.,'`
+
+# Make sure that the destination directory exists.
+# this part is taken from Noah Friedman's mkinstalldirs script
+
+# Skip lots of stat calls in the usual case.
+if [ ! -d "$dstdir" ]; then
+defaultIFS='
+'
+IFS="${IFS-${defaultIFS}}"
+
+oIFS="${IFS}"
+# Some sh's can't handle IFS=/ for some reason.
+IFS='%'
+set - `echo ${dstdir} | sed -e 's@/@%@g' -e 's@^%@/@'`
+IFS="${oIFS}"
+
+pathcomp=''
+
+while [ $# -ne 0 ] ; do
+ pathcomp="${pathcomp}${1}"
+ shift
+
+ if [ ! -d "${pathcomp}" ] ;
+ then
+ $mkdirprog "${pathcomp}"
+ else
+ true
+ fi
+
+ pathcomp="${pathcomp}/"
+done
+fi
+
+if [ x"$dir_arg" != x ]
+then
+ $doit $instcmd $dst &&
+
+ if [ x"$chowncmd" != x ]; then $doit $chowncmd $dst; else true ; fi &&
+ if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dst; else true ; fi &&
+ if [ x"$stripcmd" != x ]; then $doit $stripcmd $dst; else true ; fi &&
+ if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dst; else true ; fi
+else
+
+# If we're going to rename the final executable, determine the name now.
+
+ if [ x"$transformarg" = x ]
+ then
+ dstfile=`basename $dst`
+ else
+ dstfile=`basename $dst $transformbasename |
+ sed $transformarg`$transformbasename
+ fi
+
+# don't allow the sed command to completely eliminate the filename
+
+ if [ x"$dstfile" = x ]
+ then
+ dstfile=`basename $dst`
+ else
+ true
+ fi
+
+# Make a temp file name in the proper directory.
+
+ dsttmp=$dstdir/#inst.$$#
+
+# Move or copy the file name to the temp name
+
+ $doit $instcmd $src $dsttmp &&
+
+ trap "rm -f ${dsttmp}" 0 &&
+
+# and set any options; do chmod last to preserve setuid bits
+
+# If any of these fail, we abort the whole thing. If we want to
+# ignore errors from any of these, just make sure not to ignore
+# errors from the above "$doit $instcmd $src $dsttmp" command.
+
+ if [ x"$chowncmd" != x ]; then $doit $chowncmd $dsttmp; else true;fi &&
+ if [ x"$chgrpcmd" != x ]; then $doit $chgrpcmd $dsttmp; else true;fi &&
+ if [ x"$stripcmd" != x ]; then $doit $stripcmd $dsttmp; else true;fi &&
+ if [ x"$chmodcmd" != x ]; then $doit $chmodcmd $dsttmp; else true;fi &&
+
+# Now rename the file to the real destination.
+
+ $doit $rmcmd -f $dstdir/$dstfile &&
+ $doit $mvcmd $dsttmp $dstdir/$dstfile
+
+fi &&
+
+
+exit 0
diff --git a/scp.c b/scp.c
index faa18277..fec2f432 100644
--- a/scp.c
+++ b/scp.c
@@ -45,7 +45,7 @@
*/
#include "includes.h"
-RCSID("$Id: scp.c,v 1.10 1999/11/25 00:54:59 damien Exp $");
+RCSID("$Id: scp.c,v 1.11 1999/11/25 01:31:26 damien Exp $");
#include "ssh.h"
#include "xmalloc.h"
@@ -78,7 +78,7 @@ char *curfile;
int verbose_mode = 0;
/* This is set to non-zero if compression is desired. */
-int compress = 0;
+int compress_flag = 0;
/* This is set to zero if the progressmeter is not desired. */
int showprogress = 1;
@@ -147,7 +147,7 @@ do_cmd(char *host, char *remuser, char *cmd, int *fdin, int *fdout)
args[i++] = "-oFallBackToRsh no";
if (verbose_mode)
args[i++] = "-v";
- if (compress)
+ if (compress_flag)
args[i++] = "-C";
if (batchmode)
args[i++] = "-oBatchMode yes";
@@ -279,7 +279,7 @@ main(argc, argv)
batchmode = 1;
break;
case 'C':
- compress = 1;
+ compress_flag = 1;
break;
case 'q':
showprogress = 0;
@@ -974,7 +974,7 @@ run_err(const char *fmt,...)
* OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
* SUCH DAMAGE.
*
- * $Id: scp.c,v 1.10 1999/11/25 00:54:59 damien Exp $
+ * $Id: scp.c,v 1.11 1999/11/25 01:31:26 damien Exp $
*/
char *
diff --git a/ssh-add.c b/ssh-add.c
index 711ae126..2d0dad40 100644
--- a/ssh-add.c
+++ b/ssh-add.c
@@ -7,7 +7,7 @@
*/
#include "includes.h"
-RCSID("$Id: ssh-add.c,v 1.14 1999/11/25 00:54:59 damien Exp $");
+RCSID("$Id: ssh-add.c,v 1.15 1999/11/25 01:31:26 damien Exp $");
#include "rsa.h"
#include "ssh.h"
@@ -203,8 +203,6 @@ main(int argc, char **argv)
/* check if RSA support exists */
if (rsa_alive() == 0) {
- extern char *__progname;
-
fprintf(stderr,
"%s: no RSA support in libssl and libcrypto. See ssl(8).\n",
__progname);